<?php
/**
 * User: kristianhempel
 * Date: 04.03.13
 * automatische Installation
 */

class d3oqm_update extends d3install_updatebase
{
    // Standardwert fr checkModCfgSameRevision() und updateModCfgSameRevision()
    public $sModKey = 'd3oqm';
    public $sModName = 'D3 Bestellmengen Manager';
    public $sModVersion = '4.0.3.2';
    public $sModRevision = '241';
    public $sBaseConf = '4xrQjFEZGJzUWM4MW15dWdKSDFQMnRlaXNtR0k3bWFyS3lndGpka3RzYVhjb040TnJ5ZUlmSml5Z2g1V
2RLZzlQWHNYVFhNZWVLMzVjRGhTcUVNbHpGazhyR2h0V1VYblo1T21Ca0M5RXI1dElZMmE0WjlQeTNMb
XRPTm9SeXNFazE2Uko2Q0hQOTVJTmRTVkF3RGhUd1lXTStjRnFuM1I2TkdDbzNmL1pLakVMUjRmd1cya
3lnNEZXWVpqa3drZnl0eUN3TTFZUXBiOC9ZekpxWXdRN2FDRWFEQVBOMHlPbnJDMkhKcEwzOGRmeU5md
0NXRC8wVExwRlpXUmc1TjRXbFVQYWxPZWRQRWlqclo3d0hXejdEQ0pJQVNQU1M5WFlWeTk2cTZSV2c1S
Wc9';
    public $sRequirements = '<?xml version="1.0" encoding="UTF-8"?>
<jobs>
    <registerModule>
        <module class="oxbasket" modulepath="d3oqm/modules/application/models/d3_oxbasket_oqm" />
        <module class="oxarticle" modulepath="d3oqm/modules/application/models/d3_oxarticle_oqm" />
    </registerModule>
    <database>
        <table name="oxarticles">
            <col name="D3OQM_PACKAGE" type="double"/>
            <col name="D3OQM_MINIMUM" type="double"/>
            <col name="D3OQM_MAXIMUM" type="double"/>
        </table>
    </database>
</jobs>';
    public $sBaseValue = '';

    // auszufhrende Check- und Updateanweisungen in auszufhrender Reihenfolge
    protected $_aUpdateMethods = array(
        array(
            'check' => 'checkModCfgItemExist',
            'do'    => 'updateModCfgItemExist'
        ),
        array(
            'check' => 'checkWrongTemplateBlock',
            'do'    => 'fixWrongTemplateBlock',
        ),
        array(
            'check' => 'hasOldOxmoduleInOxtplblocks',
            'do'    => 'fixOldOxmoduleInOxtplblocks',
        ),
        array(
            'check' => 'checkFields',
            'do'    => 'fixFields'
        ),
        array(
            'check' => 'checkIndizes',
            'do'    => 'fixIndizes'
        ),
        array(
            'check' => 'hasInitialTypeField',
            'do'    => 'updateInitialTypeField',
        ),
        array(
            'check' => 'hasInitialValueField',
            'do'    => 'updateInitialValueField',
        ),
        array(
            'check' => 'checkModCfgSameRevision', // prft auf nachgezogene Revisionsnummer und bertrgt diese ggf.
            'do'    => 'updateModCfgSameRevision'
        ),
    );

    /***** Standardwerte fr aufgerufene Funktionen ********************************************/

    // alle zu aktualisierenden Module, verwendet nicht onDeactivate-Handler
    protected $_aRefreshMetaModuleIds = array('d3oqm');

    // Standardwerte fr checkFields(), _addTable() und fixFields()
    public $aFields = array(
        array(
            'sTableName'  => 'oxarticles',
            'sFieldName'  => 'D3OQM_PACKAGE',
            'sType'       => 'DOUBLE',
            'blNull'      => true,
            'sDefault'    => 0,
            'sComment'    => 'd3oqm - Bestellmengenmanager Verpackungseinheit',
            'sExtra'      => '',
            'blMultilang' => false,
        ),
        array(
            'sTableName'  => 'oxarticles',
            'sFieldName'  => 'D3OQM_MINIMUM',
            'sType'       => 'DOUBLE',
            'blNull'      => true,
            'sDefault'    => 0,
            'sComment'    => 'd3oqm - Bestellmengenmanager Minimum',
            'sExtra'      => '',
            'blMultilang' => false,
        ),
        array(
            'sTableName'  => 'oxarticles',
            'sFieldName'  => 'D3OQM_MAXIMUM',
            'sType'       => 'DOUBLE',
            'blNull'      => true,
            'sDefault'    => 0,
            'sComment'    => 'd3oqm - Bestellmengenmanager Maximum',
            'sExtra'      => '',
            'blMultilang' => false,
        ),
    );

    // Standardwerte fr checkIndizes() und fixIndizes()
    public $aIndizes = array(
        array(
            'sTableName'  => 'oxarticles',
            'sType'       => 'INDEX',
            'sName'       => 'D3OQMINDEX',
            'aFields'     => array(
                'D3OQM_PACKAGE' => 'D3OQM_PACKAGE',
                'D3OQM_MAXIMUM' => 'D3OQM_MAXIMUM',
                'D3OQM_MINIMUM' => 'D3OQM_MINIMUM',
            ),
            'blMultilang' => false,
        ),
    );

    ///----------------------------------------

    /**
     * @return bool
     */
    public function checkModCfgItemExist()
    {
        $blRet = FALSE;
        foreach ($this->_getShopList() as $oShop) {
            /** @var $oShop oxshop */
            $aWhere = array(
                'oxmodid'       => $this->sModKey,
                'oxnewrevision' => $this->sModRevision,
                'oxshopid'      => $oShop->getId(),
            );

            $blRet = $this->_checkTableItemNotExist('d3_cfg_mod', $aWhere);

            if ($blRet) {
                return $blRet;
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgItemExist()
    {
        $blRet = FALSE;

        if ($this->checkModCfgItemExist()) {
            foreach ($this->_getShopList() as $oShop) {
                /** @var $oShop oxshop */
                $aWhere        = array(
                    'oxmodid'  => $this->sModKey,
                    'oxshopid' => $oShop->getId(),
                );
                $aInsertFields = array(
                    'OXID'           => array(
                        'content'      => "md5('" . $this->sModKey . " " . $oShop->getId() . " de')",
                        'force_update' => TRUE,
                    ),
                    'OXSHOPID'       => array(
                        'content'      => "'" . $oShop->getId() . "'",
                        'force_update' => TRUE,
                    ),
                    'OXMODID'        => array(
                        'content'      => "'" . $this->sModKey . "'",
                        'force_update' => TRUE,
                    ),
                    'OXNAME'         => array(
                        'content'      => "'" . $this->sModName . "'",
                        'force_update' => TRUE,
                    ),
                    'OXACTIVE'       => array(
                        'content'      => "0",
                        'force_update' => FALSE,
                    ),
                    'OXBASECONFIG'   => array(
                        'content'      => "'" . $this->sBaseConf . "'",
                        'force_update' => TRUE,
                    ),
                    'OXINSTALLDATE'  => array(
                        'content'      => "NOW()",
                        'force_update' => TRUE,
                    ),
                    'OXVERSION'      => array(
                        'content'      => "'" . $this->sModVersion . "'",
                        'force_update' => TRUE,
                    ),
                    'OXSHOPVERSION'  => array(
                        'content'      => "'" . oxRegistry::getConfig()->getEdition() . "'",
                        'force_update' => TRUE,
                    ),
                    'OXREQUIREMENTS' => array(
                        'content'      => "'" . $this->sRequirements . "'",
                        'force_update' => TRUE,
                    ),
                    'OXVALUE'        => array(
                        'content'      => "'" . $this->sBaseValue . "'",
                        'force_update' => FALSE,
                    ),
                    'OXNEWREVISION'  => array(
                        'content'      => "'" . $this->sModRevision . "'",
                        'force_update' => TRUE,
                    )
                );
                $aRet          = $this->_updateTableItem2('d3_cfg_mod', $aInsertFields, $aWhere);
                $blRet         = $aRet['blRet'];
            }
        }
        return $blRet;
    }

    ///----------------------------------------

    /**
     * check if wrong template block
     *
     * @return bool
     */
    public function checkWrongTemplateBlock()
    {
        $blFound = false;
        /** @var $oShop oxshop */
        foreach ($this->_getShopList() as $oShop) {
            $aWhere = array(
                'oxfile'      => 'd3GetMinAmout_input_field',
                'oxblockname' => 'widget_product_listitem_grid_tobasket',
                'oxshopid'    => $oShop->getId(),
            );

            // NOTE: _checkTableItemExist returns true if not exsist
            $blFound = !$this->_checkTableItemNotExist('oxtplblocks', $aWhere);

            if ($blFound) {
                return $blFound;
            }
        }
        return $blFound;
    }

    /**
     * fix Version 3.2.0.1
     *
     * @return bool
     */
    public function fixWrongTemplateBlock()
    {
        $blRet = FALSE;

        if ($this->checkWrongTemplateBlock()) {
            /** @var $oShop oxshop */
            foreach ($this->_getShopList() as $oShop) {
                $aWhere = array(
                    'oxfile'      => 'd3GetMinAmout_input_field',
                    'oxblockname' => 'widget_product_listitem_grid_tobasket',
                    'oxshopid'    => $oShop->getId(),
                );

                // abwrtskompatibel auch mit Feldname als Key (siehe "OXNAME"), dann jedoch keine Duplikatentfernung bei mehrfacher Feldzuweisung.
                $aInsertFields = array(
                    array(
                        // Feldname ggf. sprachspezifisch mit _getLangAbbrFieldName()
                        'fieldname'     => 'OXFILE',
                        // Feldinhalt
                        'content'       => 'widget_product_listitem_grid_tobasket.tpl',
                        // bei Update, Inhalt wird berschrieben
                        'force_update'  => TRUE,
                        // Inhalt muss gequoted werden
                        'use_quote'     => TRUE,
                        // Multilang-Felder auf Basis dieses Feldes werden bei INSERT mit diesem Wert gefllt,
                        // wenn diese in der Liste nicht anderweitig belegt sind
                        'use_multilang' => FALSE,
                    ),

                );
                $aRet          = $this->_updateTableItem2('oxtplblocks', $aInsertFields, $aWhere);
                $blRet         = $aRet['blRet'];
            }
        }
        return $blRet;
    }

    /**
     * check if 'd3/d3oqm' is in oxmodule
     *
     * @return bool
     */
    public function hasOldOxmoduleInOxtplblocks()
    {
        $aWhere = array(
            'oxmodule' => 'd3/d3oqm',
        );

        // NOTE: _checkTableItemExist returns true if not exsist
        $blFound = !$this->_checkTableItemNotExist('oxtplblocks', $aWhere);

        return $blFound;
    }

    /**
     * @return bool
     */
    public function fixOldOxmoduleInOxtplblocks()
    {
        if ($this->hasOldOxmoduleInOxtplblocks()) {
            $aQueries = array(
                "DELETE FROM oxtplblocks WHERE oxmodule = 'd3/d3oqm';"
            );
            return $this->_executeMultipleQueries($aQueries);
        }
        return true;
    }

    /**
     * @param null $iDirectNumber
     * @return bool
     */
    public function hasInitialTypeField($iDirectNumber = null)
    {
        $blReturn = false;
        if ($iDirectNumber === null) {
            for ($i = 0; $i <= 2; $i++) {
                $iNumber  = $i == 0 ? null : $i;
                $blReturn = $this->_checkTableFieldExist('oxarticles', "d3_ve_type{$iNumber}");
                if ($blReturn) {
                    return $blReturn;
                }
            }
        } else {
            $iNumber  = $iDirectNumber == 0 ? null : $iDirectNumber;
            $blReturn = $this->_checkTableFieldExist('oxarticles', "d3_ve_type{$iNumber}");
        }

        return $blReturn;
    }

    /**
     * @return bool
     */
    public function updateInitialTypeField()
    {
        $blReturn = FALSE;

        for ($i = 0; $i <= 2; $i++) {
            if ($this->hasInitialTypeField($i)) {
                $iNumber  = $i == 0 ? null : $i;
                $blReturn = $this->_updateInitialTypeField($iNumber);
            }
        }

        return $blReturn;
    }

    /**
     * @param null $iNumber
     * @return bool
     */
    protected function _updateInitialTypeField($iNumber = null)
    {
        if ($this->hasInitialTypeField($iNumber)) {

            $aQueries = array(
                "UPDATE oxarticles SET D3OQM_MINIMUM = IF(d3_ve_value{$iNumber} = 0, NULL, d3_ve_value{$iNumber}) WHERE d3_ve_type{$iNumber} = 'minimum' AND D3OQM_MINIMUM = 0;",
                "UPDATE oxarticles SET D3OQM_MAXIMUM = IF(d3_ve_value{$iNumber} = 0, NULL, d3_ve_value{$iNumber}) WHERE d3_ve_type{$iNumber} = 'maximum' AND D3OQM_MAXIMUM = 0;",
                "UPDATE oxarticles SET D3OQM_PACKAGE = IF(d3_ve_value{$iNumber} = 0, NULL, d3_ve_value{$iNumber}) WHERE d3_ve_type{$iNumber} = 'package' AND D3OQM_PACKAGE = 0;",
                "ALTER TABLE `oxarticles` DROP `d3_ve_type{$iNumber}`;",
            );
            $blReturn = $this->_executeMultipleQueries($aQueries);
            $this->_getDatabaseHandler()->resetFieldCache();
            if ($blReturn) {
                $this->_blRequireViewUpdate = TRUE;
            }

            return $blReturn;
        }
        return true;
    }

    /**
     * definition array see checkFields
     * @param $sMethodName
     * @return bool
     */
    public function fixFields($sMethodName = __METHOD__)
    {
        $blReturn = parent::fixFields($sMethodName);
        if ($blReturn) {
            $this->_blRequireViewUpdate = TRUE;
        }

        return $blReturn;
    }

    /**
     * @param null $iDirectNumber
     * @return bool
     */
    public function hasInitialValueField($iDirectNumber = null)
    {
        $blReturn = false;
        if ($iDirectNumber === null) {
            for ($i = 0; $i <= 2; $i++) {
                $iNumber  = $i == 0 ? null : $i;
                $blReturn = $this->_checkTableFieldExist('oxarticles', "d3_ve_value{$iNumber}");
                if ($blReturn) {
                    return $blReturn;
                }
            }
        } else {
            $iNumber  = $iDirectNumber == 0 ? null : $iDirectNumber;
            $blReturn = $this->_checkTableFieldExist('oxarticles', "d3_ve_value{$iNumber}");
        }

        return $blReturn;
    }

    /**
     * @return bool
     */
    public function updateInitialValueField()
    {
        $blReturn = FALSE;

        for ($i = 0; $i <= 2; $i++) {
            if ($this->hasInitialValueField($i)) {
                $iNumber  = $i == 0 ? null : $i;
                $blReturn = $this->_updateInitialValueField($iNumber);
            }
        }

        return $blReturn;
    }

    /**
     * @param null $iNumber
     * @return bool
     */
    protected function _updateInitialValueField($iNumber = null)
    {
        if ($this->hasInitialValueField($iNumber)) {

            $aQueries = array(
                "ALTER TABLE `oxarticles` DROP `d3_ve_value{$iNumber}`;"
            );
            $blReturn = $this->_executeMultipleQueries($aQueries);
            $this->_getDatabaseHandler()->resetFieldCache();
            if ($blReturn) {
                $this->_blRequireViewUpdate = TRUE;
            }

            return $blReturn;
        }
        return true;
    }

}
